/*
	Copyright (C)   1995
	Edward  Der-Hua Liu,    Hsin-Chu,       Taiwan
*/

#include <sys/types.h>
#include "edit.h"

#define IGN_CASE (1)
#define BACKWARD (2)
#define WHOLEWORD (4)

int search_opt;
static char sstr[40],rep_str[40];
extern char *return_item();
static int s_row,s_col, e_row;
static first_time=0;

static search(int errmsg)
{
int i,j,k,len,slen,col;
char *ss;
slen=strlen(sstr);
if (!slen) return;

switch (search_opt&3) {
case 0:
	len=edbf[s_row].len;
	ss=edbf[s_row].cstr;
	for(j=s_col+1;j<=len-slen;j++)
		if (!memcmp(ss+j,sstr,slen)) {
			if ((search_opt&WHOLEWORD) && (j && isvardig(ss[j-1])||
				j+slen<len && isvardig(ss[j+slen])) )
				continue;
			goto found;
		}
	for(s_row++;s_row<=e_row;s_row++) {
		ss=edbf[s_row].cstr;
		len=edbf[s_row].len;
		for(j=0;j<=len-slen;j++)
		if (!memcmp(&ss[j],sstr,slen)) {
			if ((search_opt&WHOLEWORD) && (j && isvardig(ss[j-1])||
				j+slen<len && isvardig(ss[j+slen])) )
				continue;
			goto found;
		}
	}
	if (!errmsg && !first_time) return 0;
	show_cursor_w();
	message(4,"Cannot find string");
	save_win_context(active_win);
	return 0;
case 1:
	ss=edbf[s_row].cstr;
	len=edbf[s_row].len;
	for(j=s_col+1;j<=len-slen;j++) {
		for(k=0;k<slen && mtoupper(ss[k+j])==mtoupper(sstr[k]);k++);
		if (k==slen) {
		   if ((search_opt&WHOLEWORD) && (k && isvardig(ss[k-1])||
				k+slen<len && isvardig(ss[k+slen])) )
				continue;
			goto found;
		}
	}
	for(s_row++;s_row<=e_row;s_row++) {
		ss=edbf[s_row].cstr;
		len=edbf[s_row].len;
		for(j=0;j<=len-slen;j++) {
		   for(k=0;k<slen && mtoupper(ss[j+k])==mtoupper(sstr[k]);k++);
		   if (k<slen || ((search_opt&WHOLEWORD) &&	(j && isvardig(ss[j-1])||
				j+slen<len && isvardig(ss[j+slen]))) )
				continue;
			goto found;
		}
	}
	if (!errmsg && !first_time) return 0;
	disp_page();
	redraw_status();
	message(4,"Cannot find string");
	disp_mode();
	save_win_context(active_win);
	show_cursor_w();
	return 0;
case 2:
	len=edbf[s_row].len;
	ss=edbf[s_row].cstr;
	for(j=s_col-1;j>=0;j--)
		if (!memcmp(ss+j,sstr,slen)) {
			if ((search_opt&WHOLEWORD) && (j && isvardig(ss[j-1])||
				j+slen<len && isvardig(ss[j+slen])) )
				continue;
			goto found;
		}
	for(s_row--;s_row>=0;s_row--) {
		ss=edbf[s_row].cstr;
		len=edbf[s_row].len;
		for(j=len-slen;j>=0;j--)
		if (!memcmp(&ss[j],sstr,slen)) {
			if ((search_opt&WHOLEWORD) && (j && isvardig(ss[j-1])||
				j+slen<len && isvardig(ss[j+slen])) )
				continue;
			goto found;
		}
	}
	if (!errmsg && !first_time) return 0;
	show_cursor_w();
	message(4,"Cannot find string");
	save_win_context(active_win);
	return 0;
case 3:
	ss=edbf[s_row].cstr;
	len=edbf[s_row].len;
	for(j=s_col-1;j>=0;j--) {
		for(k=0;k<slen && mtoupper(ss[k+j])==mtoupper(sstr[k]);k++);
		if (k==slen) {
		   if ((search_opt&WHOLEWORD) && (k && isvardig(ss[k-1])||
				k+slen<len && isvardig(ss[k+slen])) )
				continue;
			goto found;
		}
	}
	for(s_row--;s_row>=0;s_row--) {
		ss=edbf[s_row].cstr;
		len=edbf[s_row].len;
		for(j=len-slen;j>=0;j--) {
		   for(k=0;k<slen && mtoupper(ss[j+k])==mtoupper(sstr[k]);k++);
		   if (k==slen) {
		   if ((search_opt&WHOLEWORD) && (k && isvardig(ss[k-1])||
				k+slen<len && isvardig(ss[k+slen])) )
				continue;
		   	goto found;
		   }
		}
	}
	if (!errmsg && !first_time) return 0;
	disp_page();
	redraw_status();
	message(4,"Cannot find string");
	disp_mode();
	save_win_context(active_win);
	show_cursor_w();
	return 0;
}
found:
#if	0
printf("row:%d\n",row);
#endif
hide_cursor_w();
if (s_row<page_row || s_row>=page_row+page_len) page_row=s_row-1;
if (page_row<0) page_row=0;
cursor_row=s_row;
cursor_col=j;
page_col=0;
cur_x=col2x(cursor_col);
cur_y=cursor_row-page_row;
if (cur_x+slen > page_width) {
	page_col+=cur_x-page_width+slen;
	cur_x=col2x(cursor_col);
}
save_win_context(active_win);
disp_page();
show_cursor_w();
return 1;
}

static void start_search()
{
char *s,*t;
	s=return_item(0);
	t=return_item(1);
	if (!s[0]) return;
	search_opt=0;
	s_row=cursor_row;
	s_col=cursor_col;
	e_row=Lines-1;
	for(;*t;t++)
	if (mtoupper(*t)=='I') search_opt|=IGN_CASE;
	else
	if (*t=='1') s_row=s_col=0;
	else
	if (mtoupper(*t)=='B') search_opt|=BACKWARD;
	else
	if (mtoupper(*t)=='W') search_opt|=WHOLEWORD;
	strcpy(sstr,s);
	search(1);
}

static int s_xgets_handle;
void search_menu_init()
{
s_xgets_handle=xgets_handle();
add_edln(s_xgets_handle,0,6,25,10,20);
add_edln(s_xgets_handle,1,6,25,12,4);
add_action(s_xgets_handle,start_search);
}

static XYstr sprompt[]={
{20,10,"Find"},
{20,12,"Opt"},
{30,12,"1:row 1 i:Ign case"},
{30,13,"b:backward  w:word"}
};

void enable_start_search()
{
	input_handler=1;
	save_win_context(active_win);
	inactive_cursor();
	box(18,8,32,7,7,8,"Search for string");
	xystr(sprompt,4);
	init_xgets(s_xgets_handle);
}

K_RepFind()
{
	s_row=cursor_row;
	s_col=cursor_col;
	if (sstr[0]) search(1);
	return 0;
}

static void rep_with_str()
{
char *s=edbf[cursor_row].cstr;
int len=edbf[cursor_row].len;
int slen=strlen(sstr);
int rlen=strlen(rep_str);
int nlen=len;
s_fmod();
if (rlen > slen) {
	if ((s=mrealloc(s,nlen=len+rlen-slen,"replace_str_yn"))==NULL)
		return;
	mmemmove(s+cursor_col+rlen,s+cursor_col+slen,
			len-cursor_col-slen);
} else
if (rlen < slen) {
	mmemmove(s+cursor_col+rlen,s+cursor_col+slen,
			len-cursor_col-slen);
	if ((s=mrealloc(s,nlen=len+rlen-slen,"replace_str_yn"))==NULL)
		return;
}
memcpy(s+cursor_col,rep_str,rlen);
edbf[cursor_row].cstr=s;
edbf[cursor_row].len=nlen;
cursor_col+=rlen;
s_row=cursor_row;
s_col=cursor_col;
}



static replace_str_yn(char ch)
{
if (ch=='Y') {
	rep_with_str();
	disp_page();
	show_cursor_w();
}
s_row=cursor_row;
s_col=cursor_col;
if (search(1)) {
	message(5,"Replace (Y/N):",fname);
	setup_getch(15,MROW-1,"YNyn",'Y',replace_str_yn);
	disp_page();
	show_cursor_w();
}
}

void start_replace()
{
char *s,*t,*r;
int no_prom;

s=return_item(0);
strcpy(rep_str,return_item(1));
t=return_item(2);
if (!s[0]) return;
no_prom=search_opt=0;
s_row=cursor_row;
s_col=cursor_col;
e_row=Lines-1;
for(;*t;t++)
if (mtoupper(*t)=='I') search_opt|=1;
else if (mtoupper(*t)=='N') no_prom=1;
else
if (*t=='1') s_row=s_col=0;
else
if (mtoupper(*t)=='B') search_opt|=2;
else
if (mtoupper(*t)=='L' && mline_begin>=0) {
	s_row=mline_begin; s_col=-1;
	e_row=mline_end;
	search_opt&=~2;
}

strcpy(sstr,s);
if (no_prom) {
	first_time=1;
	while (search(0)) {
		first_time=0;
		s_row=cursor_row;
		s_col=cursor_col;
		rep_with_str();
	}
	disp_page();
	show_cursor_w();
	return;
} else
if (search(1)) {
	message(5,"Replace (Y/N):",fname);
	setup_getch(15,MROW-1,"YNyn",'Y',replace_str_yn);
	show_cursor_w();
}
}

static int r_xgets_handle;
void replace_init()
{
r_xgets_handle=xgets_handle();
add_edln(r_xgets_handle,0,6,25,9,23);
add_edln(r_xgets_handle,1,6,25,11,23);
add_edln(r_xgets_handle,2,6,25,13,4);
add_action(r_xgets_handle,start_replace);
}

static XYstr rprompt[]={
{20,9,"Find"},
{20,11,"Repl"},
{20,13,"Opt"},
{30,13,"1:row 1 i:Ignore case"},
{30,14,"n:No prompt b:backward"},
{30,15,"w:word l:in Line blk"},
};

void enable_start_replace()
{
	input_handler=1;
	save_win_context(active_win);
	inactive_cursor();
	box(18,7,36,10,7,8,"Find and Replace String");
	xystr(rprompt,6);
	init_xgets(r_xgets_handle);
}

K_FindMarkStr()
{
char tt[128];
if (!GetMarkWord(tt)) return;
search_opt=0;
strcpy(sstr,tt);
search(1);
}
