/*
 *	@(#) buttons.h 12.1 95/05/09 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S002, 20-Sep-93, rickra
 *	Added disk space info...
 *
 * S001, 27-May-93, rickra
 *	Added something.....	
 * 
 *
 * S000, 30-Sep-92, rickra
 *	Added copyright and modification history
 */
/*+-------------------------------------------------------------------------
	buttons.h
--------------------------------------------------------------------------*/

typedef struct MyButtonStruct
{
	char *label;		/* Initialized in adjust_ps_button_offsets */
	int tlx,tly;		/* calculated by init code */
	int brx,bry;		/* calculated by init code */
	int width,height;	/* calculated by init code */
	Region region;		/* allocated by init code */
	int state;		/* true if "on" */
	int	offset;	        /* Initialized in adjust_ps_button_offsets */ 
	int	justification;  /* Initialized in adjust_ps_button_offsets */
} MyButton;

/* Justification states */
#define right_justification	0
#define left_justification	1



/* All "state" buttons must be first */
#define BUTTON_cpu 	0
#define BUTTON_wait 	1
#define BUTTON_cache 	2
#define BUTTON_other 	3
#define BUTTON_ps_cpu	4
#define BUTTON_ps_io	5
#define BUTTON_ps_mem	6
#define BUTTON_streams	7
#define BUTTON_nfsstat  8
#define BUTTON_sysinfo	9
#define BUTTON_tune_var 10
#define BUTTON_dev_stats 11
#define BUTTON_mem 	12
#define BUTTON_disk_space 13

#define Max_state_buttons 14


#define first_font_button 14

#define BUTTON_Default  14
#define BUTTON_6x10	15
#define BUTTON_6x12	16
#define BUTTON_6x13	17
#define BUTTON_8x13	18
#define BUTTON_9x15	19
#define BUTTON_ibm10x20 20

#define number_of_fonts 7
#define last_font_button 20

#define first_button_button		21

#define BUTTON_button_1_increase	21
#define BUTTON_button_1_decrease	22
#define BUTTON_button_1_popup		23

#define BUTTON_button_2_increase	24
#define BUTTON_button_2_decrease	25
#define BUTTON_button_2_popup		26

#define BUTTON_button_3_increase	27
#define BUTTON_button_3_decrease	28
#define BUTTON_button_3_popup		29

#define BUTTON_general_help 30
#define BUTTON_options_help 31
#define BUTTON_known_help 32

#define BUTTON_connect_server		33
#define BUTTON_disconnect_server	34


#define Max_sub_menu_buttons 35


/* All "other" buttons must be last */
#define BUTTON_fonts  	20
#define BUTTON_quit	21

/*
 * KEEP THIS sequential!!! 
 *
 * Should be able to chage the following to * start at 0.
 */

#define first_ps_literal		25

#define BUTTON_PS_state_sort		25
#define BUTTON_PS_user_sort 		26
#define BUTTON_PS_pid_sort  		27
#define BUTTON_PS_cpu_sort  		28
#define BUTTON_PS_pri_sort  		29
#define BUTTON_PS_ni_sort   		30
#define BUTTON_PS_ucpu_sort   		31
#define BUTTON_PS_scpu_sort   		32
#define BUTTON_PS_ucpu_scpu_sort   	33
#define BUTTON_PS_size_sort		34
#define BUTTON_PS_tty_sort		35
#define BUTTON_PS_cmd_sort		36
#define BUTTON_PS_cum_sort		37
#define BUTTON_PS_sort_order		38
#define BUTTON_PS_display		39

#define PS_MyButton_QUAN        15


#define first_io_ps_literal		40

#define BUTTON_IO_PS_user_sort 		40
#define BUTTON_IO_PS_pid_sort  		41
#define BUTTON_IO_PS_swap_sort		42
#define BUTTON_IO_PS_char_sort		43
#define BUTTON_IO_PS_read_sort		44
#define BUTTON_IO_PS_write_sort		45
#define BUTTON_IO_PS_total_sort		46
#define BUTTON_IO_PS_cmd_sort		47
#define BUTTON_IO_PS_cum_sort		48
#define BUTTON_IO_PS_sort_order		49

#define IO_PS_MyButton_QUAN     10


#define first_mem_ps_literal		60

#define BUTTON_MEM_PS_user_sort 	60
#define BUTTON_MEM_PS_pid_sort  	61
#define BUTTON_MEM_PS_vsize_sort	62
#define BUTTON_MEM_PS_shrd_sort		63
#define BUTTON_MEM_PS_priv_sort		64
#define BUTTON_MEM_PS_wtd_sort		65
#define BUTTON_MEM_PS_total_sort	66
#define BUTTON_MEM_PS_cmd_sort		67
#define BUTTON_MEM_PS_sort_order	68

#define MEM_PS_MyButton_QUAN    9


#define first_diskspace_literal            80

#define BUTTON_DISKSPACE_total		80
#define BUTTON_DISKSPACE_used		81
#define BUTTON_DISKSPACE_free		82
#define BUTTON_DISKSPACE_percent_used   83
#define BUTTON_DISKSPACE_percent_free   84
#define BUTTON_DISKSPACE_mountpf	85
#define BUTTON_DISKSPACE_sort_order	86
#define BUTTON_DISKSPACE_blocks		87
#define BUTTON_DISKSPACE_used_blocks	88
#define BUTTON_DISKSPACE_free_blocks	89
#define BUTTON_DISKSPACE_itotal_blocks	90
#define BUTTON_DISKSPACE_iused_blocks	91
#define BUTTON_DISKSPACE_ifree_blocks	92
#define BUTTON_DISKSPACE_percent_iused_blocks	93
#define BUTTON_DISKSPACE_percent_ifree_blocks	94




/* vi: set tabstop=4 shiftwidth=4: */
/* end of buttons.h */
