/*
 *	@(#) menus.h 1.2 92/09/30 
 */
/***************************************************************************
 *
 *	Copyright (c) 1990		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S002, 21-Sep-93, rickra
 *      Added the window_menu_struct and TOGGLE defines....
 *
 * S001, 01-Jan-93, rickra
 *      Did some minor clean up.
 * S000, 30-Sep-92, rickra
 * 	Added copyright and modification history
 */
typedef struct _menu_struct{
   char			*name;           /* name of the button */
   char			 key_name;       /* name of the key */
   void                  (*func)();       /* Callback to be invoked */
   caddr_t                data;           /* Data for the callback */
   struct _menu_struct   *sub_menu;       /* data for submenu of this button */
   int                    n_sub_items;    /* How many items in sub_menu */
   char                  *sub_menu_title; /* Title of submenu */
   int			dynamic_data_index;
 } xs_menu_struct;


#define TOGGLE_OFF	0
#define TOGGLE_ON	1
#define TOGGLE_STIPPLED	2

typedef struct _window_menu_struct{
   char			*name;           /* name of the button */
   char			 key_name;       /* name of the key */
   void                  (*func)();       /* Callback to be invoked */
   caddr_t                data;           /* Data for the callback */
   struct _window_menu_struct   *sub_menu;/* data for submenu of this button */
   int                    n_sub_items;    /* How many items in sub_menu */
   char                  *sub_menu_title; /* Title of submenu */
   int			dynamic_data_index;
   int			sort_mode;
   unsigned		state;		/* Toggled on or off  */
   int			indicatorType;  /* 0 = NONE,
					   1 = 1 of MANY,
				 	   2 = N of MANY */

 } xs_window_menu_struct;

