/*
 *	@(#) help.h 12.1 95/05/09 SCOINC
 */
/***************************************************************************
 *
 *	Copyright (c) 1990-1993		The Santa Cruz Operation, Inc.
 *
 *	All rights reserved.  No part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form or
 *	by any means, electronic, mechanical, magnetic, optical, chemical,
 *	biological, or otherwise, without the prior written permission of:
 *	
 *		The Santa Cruz Operation , Inc.		(408) 425-7222
 *		400 Encinal St., Santa Cruz, California 95060 USA
 *
 **************************************************************************/
/*
 * Modification History
 *
 * S003, 21-Sep-93, rickra
 *	Added info on disk space.....
 *
 * S002, 27-May-93, rickra
 * 	Added the PS MEM View stuff.....
 *
 * S001, 01-Jan-93, rickra
 * 	Did some minor clean up.
 * S000, 30-Sep-92, rickra
 * 	Added copyright and modification history
 */

char 	*help_string_general[] = {
/*2345678901234567890123456789012345678901234567890-------------------*/
"		              XSW - X System Watch\n",
"\n",
"\n",
"\n",
/*--------------------------------------------------------------------*/
"Xsw is a X system watch program that monitors a system and displays\n",
"information in a meaningful manner. There are several viewing options\n",
"listed below with a brief description of their displays. \n",
"\n",
"\n",
"Main Display - The main display contains the following, from left to \n",
"right:\n",
"\n",
"	The chosen interval.\n",
"	The actual interval.\n",
"	The number of users currently on the system.\n",
"\n",
"	To change the interval, you must press '+' to increase the \n",
"	interval or '-' to decrease the sampling interval. Please note\n",
"	that if xsw cannot keep	up with the choosen interval rate, xsw\n",
"	will 'fall behind' and it will appear that xsw is not responding\n",
"	to your commands. Thus, it is important	to be sure that the \n",
"	actual interval is not much greater than the choosen interval.\n",
"	Any color, if you have color available, other than green, means\n",
"	that xsw is having problems maintaining the choosen interaval.\n",
"	The choosen interval is always constant.\n",
"\n",
"\n",
"CPU - 	Displays CPU usage broken down into user, kernel, and break. The\n",
"	numbers presented represent a percent of the total. Averages are\n",
"	given by the current interval sample, I, I*5, and I*10. As the\n",
"	interval changes, so does each subsequent interval calculations.\n",
"\n",
"\n",
"Wait -	Displays CPU Wait broken down into I/O, page I/O and swap. The\n",
"	numbers presented represent a percent or the total. Averages are\n",
"	given by the current interval sample, I, I*5 and I*10. As the\n",
"	interval changes, so does each subsequent interval calculations.\n",
"\n",
"\n",
"Cache - Display disk cache hit percentage. The number presented is the\n",
"	percent hit for either read or write. An average is also\n",
"	presented which is calculated over time from the initial display.\n",
"\n",
"\n",
"Other - Displays NFILES, NINODES, NPROC, NREGION, and CBLOCKS usage. The\n",
"	numbers presented are: currently configured into the kernel, the\n",
"	maximum that was allocated, and the current allocation.\n",
"\n",
"\n",
"MEM   - Displays memory usage.  % Memory in use, % Swap in use,\n",
"	and  % \"virtual\" physical memory.\n",
"\n",
"\n",
"PS CPU - Displays CPU usage by process. The display consist of:\n",
"\n",
"	S    - The state of the process..\n",
"		s - The process is sleeping\n",
"		R - The process is running\n",
"		p - The process is on the run queue\n",
"		S - The process is in core.\n",
"	USER - The user of the process.\n",
"	PID  - The Process ID.\n",
"	CPU  - Processor utilization for scheduling.\n",
"	PRI  - The priority of the process.\n",
"	NI   - The nice value, used in priority computation.\n",
"	UCPU - The User process time.\n",
"	SCPU - The System process time.\n",
"	SIZE - The size of the swappable process's image in main memory.\n",
"	TTY  - The controlling terminal for the process(the message '??'\n",
"	       is printed when there is no controlling terminal).\n",
"	CMD  - The command name.\n",
"\n",
"\n",
"PS IO - Displays Disk I/O on a per process basis. The display consis\n",
"	of:\n",
"\n",
"	USER  - The user of the process.\n",
"	PID   - The Process ID.\n",
"	SWAP  - The number of blocks transfered to or from a swap device.\n",
"	CHAR  - The number of bytes read or written.\n",
"	READ  - The number of blocks read.\n",
"	WRITE - The number of blocks written.\n",
"	TOTAL - The  sum of READ and WRITE.\n",
"\n",
"\n",
"PS MEM - Displays memory in several different ways, depending upon the .\n",
"	\"VIEW\" choosen:\n",
"\n",
"	\"S & P\": In core memory broken down by shared and private.\n",
"\n",
"	USER  - The user of the process.\n",
"	PID   - The Process ID.\n",
"	VSIZE - The virtual size of the process. This is the maximum\n",
"		size of the process.\n",
"	SHRD  - This is the shared memory size of the process.\n",
"	PRIV  - This is the privated memory size of the process.\n",
"	WTD   - This is the weighted memory size of this process.\n",
"		Basically, this number is the shared memory size divided\n",
"		by the reference count.\n",
"	TOTAL - This is the total in core memory size.\n",
"	CMD   - The command name.\n",
"\n",
"\n",
"	\"CORE DBD\": DBD that is in core memory only.\n",
"\n",
"	USER  - The user of the process.\n",
"	PID   - The Process ID.\n",
"	VSIZE - The virtual size of the process. This is the maximum\n",
"		size of the process.\n",
"	NONE  - Memory that the process has allocated.\n",
"	SWAP  - Swap memory that is in core.\n", 
"	FILE  - File memory that is in core.\n",
"	LSTFILE - Last file memory that is in core.\n",
"	TOTAL - Total memory in core.\n",
"	CMD   - The command name.\n",
"\n",
"\n",
"	\"ALL DBD\": All memory types, regaurdless of their location.\n",
"\n",
"	USER  - The user of the process.\n",
"	PID   - The Process ID.\n",
"	VSIZE - The virtual size of the process. This is the maximum\n",
"		size of the process.\n",
"	NONE  - Memory that the process has allocated.\n",
"	SWAP  - Memory that is in core as well as swap.\n", 
"	FILE  - Memory that is in core as well as in file.\n",
"	LSTFILE - Memory that is in core as well as in last file.\n",
"	ZERO  - Memory that the process has allocated, but not touched yet.\n",
"	FILL  - Memory that the process ???.\n",
"	IOMAP - Memory that s I/O mapped.\n",
"	WINDOW - Special memory type.\n",
"	CMD   - The command name.\n",
"\n",
"\n",
"	\"NONE CORE DBD\": DBD that is NOT in core.\n",
"\n",
"	USER  - The user of the process.\n",
"	PID   - The Process ID.\n",
"	VSIZE - The virtual size of the process. This is the maximum\n",
"		size of the process.\n",
"	SWAP  - Memory that is on swap only.\n", 
"	FILE  - Memory that is on file only.\n",
"	LSTFILE - Memory that is on last file only.\n",
"	ZERO  - Memory that the process has allocated, but not touched yet.\n",
"	FILL  - Memory that the process ???.\n",
"	IOMAP - Memory that s I/O mapped.\n",
"	WINDOW - Special memory type.\n",
"	CMD   - The command name.\n",
"\n",
"\n",
"Streams - Displays streams statistics. The number presented are: \n",
"\n",
"	Config - What is currently configured into the system.\n",
"	Use    - The current item usage count.\n",
"	%Use   - The percent of Config in use.\n",
"	Total  - The total item usage count.\n",
"	Max    - The maximum item usage count.\n",
"	Fail   - The count of allocations failures.\n",
"\n",
"	across these structures:\n",
"\n",
"	NSTREAM  - Stream allocation data.\n",
"	NQUEUE   - Queue allocation data.\n",
"	MBLOCK   - Message block allocation data.\n",
"	DBLK TOT - Aggredate data block allocation data.\n",
"	DBLK4    - 4 byte stream buffer.\n",
"	DBLK16   - 16 byte stream buffer.\n",
"	DBLK64   - 64 byte stream buffer.\n",
"	DBLK128  - 128 byte stream buffers.\n",
"	DBLK256  - 256 byte stream buffers.\n",
"	DBLK512  - 512 byte stream buffers.\n",
"	DBLK1024 - 1024 byte stream buffers.\n",
"	DBLK2048 - 2048 byte stream buffers.\n",
"	DBLK4096 - 4096 byte stream buffers.\n",
"\n",
"\n",
"NFS stat - Displays statistics on both the client and server side of\n",
"	NFS.\n",
"\n",
"    NFS client:\n",
"\n",
"	calls    - The total number of calls.\n",
"	badcalls - The number of rejected NFS calls.\n",
"	nclget   - The number of times the client had to request a new\n",
"		   handle for an NFS call.\n",
"	nclsleep - The number of times a NFS call was blocked becasue no\n",
"		   client was currently availble. Please see man page on\n",
"		   nfsclnt if this number is greater than 0.\n",
"\n",
"	null - fsstat - Breakdown of NFS calls by procedure.\n",
"\n",
"    NFS server:\n",
"\n",
"	calls    - The total number of calls.\n",
"	badcalls - The number of rejected NFS calls.\n",
"\n",
"	null - fsstat - Breakdown of NFS calls by procedure.\n",
"\n",
"    RPC client:\n",
"	calls    - The total number of calls made to all NFS servers.\n",
"	badcalls - The number of RPC calls that returned an error.\n",
"	retrans  - The number of calls that were retransmitted because\n",
"		   not reponse was recieved from the NFS server within\n",
"		   the timeout period.\n",
"	badxid   - Indicates that the server is recieving some\n",
"		   retransmitted requests, but is taking a long time to\n",
"		   reply to all NFS requests.\n",
"	timeout  - Number of calls that timed out waiting for a server\n",
"		   response.\n",
"	wait     - The number of calls that had to wait on a busy client\n",
"		   handle to be refreshed.\n",
"	peekerrs - The number of 'peek' into call message that failed.\n",
"	badresps - The number of minimal reply message size failures.\n",
"\n",
"    RPC server:\n",
"	calls    - The total number of NFS RPC calls made to this server,\n",
"		    from all clients.\n",
"	badcalls - The number of RPC calls that were rejected, before the\n",
"		   request was passed to the NFS service routines.\n",
"	nullrecv - The number of times an nfsd daemon is scheduled to run\n",
"	  	   but finds that there is no packet on the NFS service\n",
"		   socket queue.\n",
"	badlen   - The RPC request recieved by the server was too short.\n",
"	xdrcall  - The XDR headers in the packet are malformed.\n",
"\n",
"\n",
"Sysinfo - Displays the sysinfo and minfo data structures. These data\n",
"	   structures contain a wide range of kernel statistics.\n",
"\n",
"\n",
"VBT     - Displays the var, bootinfo and tune data structures. These\n",
"	   data structures contain a wide range of kernel static\n",
"	   values.\n",
"\n",
"\n",
"Device Stats. - Displays activity for each block device. Items displayed\n",
"are:\n",
"\n",
" %busy, avque -- portion of time the device was busy servicing a transfer\n",
" 		  request, average number of requests outstanding during \n",
"		  that time.\n",
"\n",
" r+w/s, blks/s -- number of data transfers from or to device, number\n",
"		   of bytes transferred in 512-byte units.\n",
"\n",
" avwait, avserv -- average time, in milliseconds, that transfer requests\n",
"		    wait idly on queue, and average time to be serviced\n",
"		    (which for disks includes seek, rotational latency, and\n",
"		    data transfer times).\n",
"\n",
"\n",
"Disk Space - Displays disk space free and used for on-line filesystems by\n",
"	      examining the counts kept in the super-blocks.\n",
"	      Those filesystem which are not accessable will be denoted by\n",
"	      a question mark at the begining of the filesystem totals.\n",
"\n",
"ALLDONE"};

char 	*help_string_options[] = {
"			 	  XSW Options\n",
"\n",
"\n",
"\n",
"Xsw provides for many options at start up time, as will as some run\n",
"time options. The follwing is a list of start up options, each with\n",
"a brief explantion.\n",
"\n",
"-help				print out this message\n",
"-geometry			size (in characters) and position\n",
"-title				title for the xsw window\n",
"-server \n",
"   host[:window,window,..]	specifies a server to connect to and \n",
"				resource window to pop up. Resource window\n",
"				can be one of: cpu,wait,cache,other,pscpu,\n",
"				psio,psmem,streams,nfs,sysinfo,vbt,disk,mem,\n",
"				diskspace\n",
"-bg color			background color\n",
"-fg color			foreground color\n",
"-fn fontname			text font\n",
"-labelc color			text label color\n",
"-titleb color			text foreground color for window title bars\n",
"-uc color			User CPU percentage scale color\n",
"-kc color			Kernel CPU percentage scale color\n",
"-bc color			Break CPU percentage scale color\n",
"-ic color			I/O wait percentage scale color\n",
"-pc color			Page I/O wait percentage scale color\n",
"-sc color			Swap I/O wait percentage scale color\n",
"-rca percent			Read Cache Hit alarm percentage\n",
"-wca percent			Write Cache Hit alarm percentage\n",
"-rcw percent			Read Cache Hit warning percentage\n",
"-wcw percent			Write Cache Hit warning percentage\n",
"-nfilec color			NFILE percentage scale color\n",
"-ninodec color			NINODE percentage scale color\n",
"-nprocc color			NPROC percentage scale color\n",
"-nregionc color			NREGION percentage scale color\n",
"-nfileac color			NFILE Alarm percentage scale color\n",
"-ninodeac color			NINODE Alarm percentage scale color\n",
"-nprocac color			NPROC Alarm percentage scale color\n",
"-nregionac color		NREGION Alarm percentage scale color\n",
"-nfileat percent		NFILE Alarm percent Threshhold\n",
"-ninodeat percent		NINODE Alarm percent Threshhold\n",
"-nprocat percent		NPROC Alarm percent Threshhold\n",
"-nregionat percent		NREGION Alarm percent Threshhold\n",
"-nfilewc color			NFILE Warning percentage scale color\n",
"-ninodewc color			NINODE Warning percentage scale color\n",
"-nprocwc color			NPROC Warning percentage scale color\n",
"-nregionwc color		NREGION Warning percentage scale color\n",
"-nfilewt percent		NFILE Warning percent Threshhold\n",
"-ninodewt percent		NINODE Warning percent Threshhold\n",
"-nprocwt percent		NPROC Warning percent Threshhold\n",
"-nregionwt percent		NREGION Warning percent Threshhold\n",
"-psmemc color			Memory color\n",
"-psmemgrowc color		PS Memory growing color\n",
"-psmemshrinkc color		PS Memory shrinking color\n",
"-psmemnewc color		PS Memory new color\n",
"-pscpuidlec color		PS CPU idle color\n",
"-pscpuactivec color		PS CPU active color\n",
"-pscpunewc color		PS CPU new color\n",
"-pscpurunc color		PS CPU running color\n",
"-psioidlec color		PS IO idle color\n",
"-psioactivec color		PS IO active color\n",
"-psionewc color			PS IO new color\n",
"-memusedc color			Memory Used color\n",
"-memusedwc color		Memory Used Warning color\n",
"-memusedac color		Memory Used Alarm color\n",
"-muwt percent 			Memory Used Warning Threshhold\n",
"-muat percent 			Memory Used Alarm Threshhold\n",
"-swapusedc color		Swap Memory Used color\n",
"-swapusedwc color		Swap Memory Used Warning color\n",
"-swapusedac color		Swap Memory Used Alarm color\n",
"-suwt percent 			Swap Memory Used Warning Threshhold\n",
"-suat percent 			Swap Memory Used Alarm Threshhold\n",
"-disklosingc color		Disk Space Losing color\n",
"-diskgainingc color		Disk Space Gaining color\n",
"-diskstablec color		Disk Space Stable color\n",
"-availswapusedc color		Avail. Swap Memory Used color\n",
"-availswapusedwc color		Avail. Swap Memory Used Warning color\n",
"-availswapusedac color		Avail. Swap Memory Used Alarm color\n",
"-asuwt percent 			Avail. Swap Memory Used Warning Threshhold\n",
"-asuat percent 			Avail. Swap Memory Used Alarm Threshhold\n",
"-auxbtnonbgc color		Auxillary Buttons \"ON\" Background\n",
"-auxbtnonffgc color		Auxillary Buttons \"ON\" Foreground\n",
"-auxbtnoffbgc color		Auxillary Buttons \"OFF\" Background\n",
"-auxbtnofffgc color		Auxillary Buttons \"OFF\" Foreground\n",
"-numericc color			Numeric color\n",
"-numericwc color		Numeric Warning color\n",
"-numericac color		Numeric Alarm color\n",
"-snumericc color		Static Numeric color\n",
"\n",
"\n",
"\ALLDONE"};

char 	*help_string_problems[] = {
"			       XSW Known Problems \n",
"\n",
"\n",
"\n",
"	1) NQUEUE data structure is not accurate in the kernel......\n",
"\n",
"\n",
"ALLDONE"};
